.386 
.model flat,stdcall 
option casemap:none 

include				windows.inc 
include				user32.inc 
include				kernel32.inc 
include 			comdlg32.inc
include 			comctl32.inc
include 			macros.asm
includelib			user32.lib 
includelib			kernel32.lib 
includelib 			comdlg32.lib
includelib         	comctl32.lib



WinMain PROTO :HINSTANCE, :HINSTANCE, :SDWORD
DlgProc PROTO :HWND, :UINT, :WPARAM, :LPARAM
ChildDlgProc proto		:DWORD,:DWORD,:DWORD,:DWORD 

.const

IDC_TAB1  		EQU  1011


.data

szMainDlgName	DB "IDD_DIALOG1", 0		; main dlg
szNameChild1		DB "IDD_CHILD1", 0		; first child
szNameChild2		DB "IDD_CHILD2", 0		; second child

szTabTitle1		DB "ex1", 0				
szTabTitle2		DB "ex2", 0
szTabTitle3		DB "ex3", 0
szTabTitle4		DB "ex4", 0

.data?

hInstance				HINSTANCE	?
hwndTab					HANDLE ?			; Handle for the Tab Control

Handles LABEL 	DWORD					; Reference to locate the handles
hWndChild1			HANDLE ?			; Handle for the first child dialog 
hWndChild2			HANDLE ?			; Handle for child dialog number 2

ItemStruct			TC_ITEM <?>		; Structure used by the Tab Control
WhichTabChosen	DWORD ?


.code
start:

	invoke GetModuleHandle, NULL
	mov	hInstance, eax
	invoke InitCommonControls		; load comctl32.dll!
	invoke WinMain, hInstance, NULL, SW_SHOWDEFAULT
	invoke ExitProcess, eax


WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdShow:SDWORD

	invoke DialogBoxParam, hInst, OFFSET szMainDlgName, NULL, OFFSET DlgProc, NULL
	ret

WinMain endp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	mov   eax, uMsg
		.if eax == WM_INITDIALOG
			invoke InitCommonControls									; load comctl32.dll!
			invoke GetDlgItem, hWnd, IDC_TAB1 							; Handle to the Tab Control
			mov hwndTab, eax
			; Add tabs to tab control
			; Fill the TC_ITEM Struct
			mov ItemStruct.imask, TCIF_TEXT								; Text? image?
			mov ItemStruct.lpReserved1, 0									; Reserved
			mov ItemStruct.lpReserved2, 0									; Reserved
			
			mov ItemStruct.pszText, OFFSET szTabTitle1						; pointer to string
			mov ItemStruct.cchTextMax, sizeof szTabTitle1						; size of pszText
			
			mov ItemStruct.iImage, 0										; index to tab control's image 
			mov ItemStruct.lParam, 0										; Extra info
			invoke SendMessage, hwndTab, TCM_INSERTITEM, 0, OFFSET ItemStruct
			
			; Now we add the second Tab title ==========================
			mov ItemStruct.pszText, OFFSET szTabTitle2
			mov ItemStruct.cchTextMax, sizeof szTabTitle2
			invoke SendMessage, hwndTab, TCM_INSERTITEM, 1, OFFSET ItemStruct
			mov ItemStruct.pszText, OFFSET szTabTitle3
			mov ItemStruct.cchTextMax, sizeof szTabTitle3
			invoke SendMessage, hwndTab, TCM_INSERTITEM, 2, OFFSET ItemStruct
			mov ItemStruct.pszText, OFFSET szTabTitle4
			mov ItemStruct.cchTextMax, sizeof szTabTitle4
			invoke SendMessage, hwndTab, TCM_INSERTITEM, 3, OFFSET ItemStruct
			
			; We now create the dialogs that will fit into the tab control
			invoke CreateDialogParam, hInstance, OFFSET szNameChild1, hwndTab, OFFSET ChildDlgProc, 0
			mov hWndChild1, eax
			invoke CreateDialogParam, hInstance, OFFSET szNameChild2, hwndTab, OFFSET ChildDlgProc, 0
			mov hWndChild2, eax
			mov WhichTabChosen, 0				
			invoke ShowWindow, hWndChild1, SW_SHOWDEFAULT
			RET
		.elseif eax == WM_COMMAND
			mov eax, wParam
			RET
		.elseif eax == WM_NOTIFY
			mov eax, lParam											; lParam is a pointer to a NMHDR Struct
			mov eax, (NMHDR PTR [eax]).code
				.if eax == TCN_SELCHANGE
					mov EBX, WhichTabChosen							; Which is the currently selected tab?
					mov eax, [Handles+EBX*4]							; Put in eax its handle
					invoke ShowWindow, eax, SW_HIDE					; Hide it damn it!
					invoke SendMessage, hwndTab, TCM_GETCURSEL, 0, 0	; Ok which one is BEING chosen right now?
					mov WhichTabChosen, eax							; Lets keep it in our little variable
					mov EBX, [Handles+eax*4]							; Now lets retrieve the chosen one's handle
					invoke ShowWindow, EBX, SW_SHOWDEFAULT			; and now lets show it :)
				.endif
		.elseif eax == WM_CLOSE
			invoke ExitProcess, 0
			RET  
		.endif
	xor eax, eax
	ret
DlgProc endp


ChildDlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

    xor	eax,eax
    ret 
ChildDlgProc	ENDP

END start
